#include <stdio.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/socket.h>
#include <netdb.h>
#include <unistd.h>
#include <time.h>
#include <string.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/ioctl.h>

#define VERSION "0.3"

int do_connect(char *host, char *port);
int do_listen(char *port);

int once=0;

int main(int ac, char **av)
{
   fd_set s_read, d_read;
   char buffer[2048];
   int s_sock, d_sock;
   int fd;
   int i;
   
   if (ac < 4)
     {
	fprintf(stderr, "Usage : %s lport rhost rport [options]\n", av[0]);
	fprintf(stderr, "Options:\n");
	fprintf(stderr, "-once   only run once then die\n");
	fprintf(stderr, "\nRelay %s by Laq\n", VERSION);
	exit(1);
     }
   
   if (ac >= 5)
     for (i=4; i <ac; i++)
     {
	if (!strcmp(av[i],"-once"))
	  once=1;
     }
   
   
   printf("Relaying port %s -> %s:%s\n", av[1], av[2], av[3]);
   
   if (once)
     printf("Running only once\n");
   
   fd = open("/dev/tty", O_RDWR);
   if (ioctl(fd, TIOCNOTTY, "1") < 0)
     {
	perror("ioctl");
	exit(1);
     }
   if (fork() != 0)
     exit(1);
   else
     close(fd);
   
   while(1)
     {
	s_sock = do_listen(av[1]);
	d_sock = do_connect(av[2], av[3]);
	
	while(1)
	  {
	     struct timeval timeout;
	     int status;
	     
	     FD_ZERO(&s_read);
	     FD_SET(s_sock, &s_read);	     
	     timeout.tv_sec = 1;
	     timeout.tv_usec = 0;
	     bzero(buffer, 2048);
	     select(s_sock+1, &s_read, NULL, NULL, &timeout);
	     	     
	     if (FD_ISSET(s_sock, &s_read))
	       {
		  status = recv(s_sock, buffer, 2048, 0);
		  if (status == 0)
		    exit(1);
		  if (send(d_sock, buffer, status, 0) == 0)
		    exit(1);
	       }
	     
	     FD_ZERO(&d_read);
	     FD_SET(d_sock, &d_read);	     
	     timeout.tv_sec = 1;
	     timeout.tv_usec = 0;
	     bzero(buffer, 2048);
	     select(d_sock+1, &d_read, NULL, NULL, &timeout);

	     if (FD_ISSET(d_sock, &d_read))
	       {
		  status = recv(d_sock, buffer, 2048, 0);
		  if (status == 0)
		    exit(1);
		  if (send(s_sock, buffer, status, 0) == 0)
		    exit(1);
	       }
	  }
		  
	     
	     
	     
	     
   
     }
}
   
int do_connect(char *host, char *port)
{
   struct hostent *he;
   struct sockaddr_in addr;
   int sock;
   
   sock = socket(AF_INET, SOCK_STREAM, 0);
   if (sock < 0)
     {
	perror("socket");
	exit(1);
     }
      
   addr.sin_port = htons(strtol(port, NULL, 0));
   addr.sin_family = AF_INET;
   
   he = gethostbyname(host);
   if (he == NULL)
     addr.sin_addr.s_addr = inet_addr(host);
   else
     memcpy((void *)&addr.sin_addr, he->h_addr_list[0], sizeof(struct in_addr));
   
   if (connect(sock, (struct sockaddr *)&addr, sizeof(addr)) < 0)
     {
	perror("connect");
	exit(1);
     }
   
   return sock;
}

int do_listen(char *port)
{
   struct sockaddr_in addr;
   int mainsock;
   int sock;
   int len;
   
   mainsock = socket(AF_INET, SOCK_STREAM, 0);
   if (mainsock < 0)
     {
	perror("socket");
	exit(1);
     }
      
   addr.sin_family = AF_INET;
   addr.sin_addr.s_addr = INADDR_ANY;
   addr.sin_port = htons(strtol(port, NULL, 0));
   
   if (bind(mainsock, (struct sockaddr *)&addr, sizeof(addr)) < 0)
     {
	perror("bind");
	exit(1);
     }
   
   if (listen(mainsock, 3) < 0)
     {
	perror("listen");
	exit(1);
     }
    
   while (1)
     {
	len = sizeof(addr);
	sock = accept(mainsock, (struct sockaddr *)&addr, &len);
	
	if (sock < 0)
	  {
	     perror("accept");
	     exit(1);
	  }
	
	if (once)
	  break;
	
	if (fork() == 0)
	  {
	     close(sock);
	     continue;
	  }
	else
	  break;
     }
   
   return sock;
}
